/******************************************************************************
CIF_Comm_Factory.H

Description:

  CIF Object Factory

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Comm_Factory.H,v $
  $Date: 1998/09/25 15:08:34 $
  $Revision: 1.4 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#if !defined(CIF_INCLUDE_COMM_FACTORY)
#define CIF_INCLUDE_COMM_FACTORY

/******************************************************************************
			   Define CIF_Comm_Factory class
******************************************************************************/
class
CIF_Comm_Factory
{
    public: static
    CIF_Comm_Connection *
    get_Connection(
	ARG_IN const char * const		url);
    
    public: static
    CIF_Comm_Connection *
    get_Connection(
	ARG_IN const char * const		url,
	ARG_IN const CIF_Toolkit_Timeout &	timeout);
    
    public: static
    CIF_Comm_Connection *
    get_Connection(
	ARG_IN const char * const		url,
	ARG_IN const
	CIF_Comm_Connection::Properties &	properties);
    
    public: static
    CIF_Comm_Connection *
    get_Connection(
	ARG_IN const char * const		url,
	ARG_IN const
	CIF_Comm_Connection::Properties &	properties,
	ARG_IN const CIF_Toolkit_Timeout &	timeout);

    public: static
    CIF_Comm_Listener *
    get_Listener(
	ARG_IN const char * const		url);

    public: static
    CIF_Comm_Listener *
    get_Listener(
	ARG_IN const char * const		url,
	ARG_IN const
	CIF_Comm_Listener::Properties &		properties);

    private: static
    CIF_Comm_Connection *
    l_get_Connection(
	ARG_IN const char *			url,
	ARG_IN const
	CIF_Comm_Connection::Properties &	properties,
	ARG_IN const CIF_Toolkit_Timeout &	timeout);

    private: static
    CIF_Comm_Listener *
    l_get_Listener(
	ARG_IN const char *			url,
	ARG_IN const
	CIF_Comm_Listener::Properties &		properties);
};

#endif /* CIF_INCLUDE_COMM_FACTORY */

