
AC_DEFUN(LAC_SSL_ARGS,
[
dnl Allow the user to supply the SSL path
AC_ARG_WITH(ssl-path,
        [  --with-ssl-path=DIR           use SSL files in DIR],
        [if test `echo "$withval" | cut -c1-1` = "/" 
         then
                 ssl_path="$withval"
         else
                 ssl_path="lac_base_path/$withval"
         fi
        ],
        [ssl_path="/usr/local/ssl"])

AC_SUBST(ssl_path)

if test "$globus_cv_gssapi_ssleay_enable" = "yes" ; then
  echo checking for $ssl_path/include/ssl.h 1>&6
  echo "configure:XXXX: checking for $ssl_path/include/ssl.h" >&5

  if test ! -f $ssl_path/include/ssl.h ; then 
     AC_MSG_ERROR(Unable to find SSL installed files)
  fi  
fi


])

AC_DEFUN(LAC_SSL,
[
   LAC_SSL_ARGS
])

